	Name    INT13_F

	Public  DiskReset,DiskReadSector,DiskVerifySector,DiskWriteSector
	Public  DiskSetMedia,DiskFormatTrack
	Public  DiskGetDPT,DiskPutDPT

	Title   INT13_F.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        900311
;***************************************************************************

	extrn   STRINGADDRESS:far
	extrn   STRINGLENGTH:far

;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'
	strOff  dw      ?               ;string offset  BC7
	strSeg  dw      ?               ;string segment BC7
	StrLen  dw      ?               ;string length  BC7
	data    ends

	dgroup  group   data


;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

;---------------------------------------------------------------------------
; DiskReset
;---------------------------------------------------------------------------
	DiskReset       proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di
		mov     bx,[bp+06]
		mov     dl,[bx]
		mov     ah,00
		int     13h
		mov     al,ah
		xor     ah,ah
		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters
	DiskReset       endp

;---------------------------------------------------------------------------
; DiskReadSector
;---------------------------------------------------------------------------
	DiskReadSector      proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+06]              ;get string addr in ax
		push    bx
		call    STRINGADDRESS
		mov     es,dx
		mov     bx,ax

		push    bx
		mov     bx,[bp+16]              ;get dl
		mov     dl,[bx]
		mov     bx,[bp+14]              ;get dh
		mov     dh,[bx]
		mov     bx,[bp+12]              ;get ch
		mov     ch,[bx]
		mov     bx,[bp+10]              ;get cl
		mov     cl,[bx]
		pop     bx
		mov     ax,0201h
		int     13h                     ;call read sector
		jnc     read_ok
		jmp     read_code
read_ok:        xor     ax,ax
read_code:      mov     al,ah
		xor     ah,ah
		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     12                      ;return 2xParameters
	DiskReadSector      endp

;---------------------------------------------------------------------------
; DiskVerifySector
;---------------------------------------------------------------------------
	DiskVerifySector      proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+06]              ;get string addr in ax
		push    bx
		call    STRINGADDRESS
		mov     es,dx
		mov     bx,ax

		push    bx
		mov     bx,[bp+16]              ;get dl
		mov     dl,[bx]
		mov     bx,[bp+14]              ;get dh
		mov     dh,[bx]
		mov     bx,[bp+12]              ;get ch
		mov     ch,[bx]
		mov     bx,[bp+10]              ;get cl
		mov     cl,[bx]
		pop     bx
		mov     ax,0201h
		int     13h                     ;call read sector
		jnc     vf_ok
		jmp     vf_code
vf_ok:          xor     ax,ax
vf_code:        mov     al,ah
		xor     ah,ah
		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     12                      ;return 2xParameters
      DiskVerifySector      endp

;---------------------------------------------------------------------------
; DiskWriteSector
;---------------------------------------------------------------------------
	DiskWriteSector     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+06]              ;get string addr in ax
		push    bx
		call    STRINGADDRESS
		mov     es,dx
		mov     bx,ax

		push    bx
		mov     bx,[bp+16]              ;get head nr in dh
		mov     dl,[bx]
		mov     bx,[bp+14]              ;get track nr in ch
		mov     dh,[bx]
		mov     bx,[bp+12]              ;get sector nr in cl
		mov     ch,[bx]
		mov     bx,[bp+10]              ;get al
		mov     cl,[bx]
		pop     bx
		mov     ax,0301h
		int     13h                     ;call read sector

		jnc     wrt_ok
		jmp     wrt_code
wrt_ok:         xor     ax,ax
wrt_code:       mov     al,ah
		xor     ah,ah
		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     12                      ;return 2xParameters
	DiskWriteSector     endp

;---------------------------------------------------------------------------
; DiskSetMedia
;---------------------------------------------------------------------------
	DiskSetMedia    proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di
		mov     bx,[bp+10]              ;get track nr in ch
		mov     dl,[bx]
		mov     bx,[bp+08]              ;get track nr in ch
		mov     ch,[bx]
		mov     bx,[bp+06]              ;get sector nr in cl
		mov     cl,[bx]
		mov     ah,18h
		int     13h                     ;call set media type
		jnc     dsm_ok
		jmp     dsm_ejjoj
dsm_ok:         xor     ax,ax
dsm_ejjoj:      mov     al,ah
		xor     ah,ah
		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     06                      ;return 2xParameters
	DiskSetMedia    endp

;---------------------------------------------------------------------------
; DiskFormatTrack
;---------------------------------------------------------------------------
	DiskFormatTrack     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+06]              ;get string addr in ax
		push    bx
		call    STRINGADDRESS
		mov     es,dx
		mov     bx,ax

		push    bx
		mov     bx,[bp+12]              ;get track nr in ch
		mov     dl,[bx]
		mov     bx,[bp+10]              ;get track nr in ch
		mov     dh,[bx]
		mov     bx,[bp+08]              ;get sector nr in cl
		mov     ch,[bx]
		pop     bx
		xor     cl,cl
		xor     al,al
		mov     ah,05
		int     13h                     ;call read sector

		jnc     fmt_ok
		jmp     fmt_code
fmt_ok:         xor     ax,ax
fmt_code:       mov     al,ah
		xor     ah,ah
		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     08                      ;return 2xParameters
	DiskFormatTrack     endp

;---------------------------------------------------------------------------
; DiskGetDPT
;---------------------------------------------------------------------------
	DiskGetDPT          proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+08]              ;get item
		mov     si,[bx]

		mov     al,1eh                  ;get old vector
		mov     ah,35h                  ;returned in ES:BX
		int     21h

		mov     al,es:[bx+si]           ;get item from
		xor     ah,ah                   ;DPT

		mov     bx,[bp+06]              ;return item
		mov     [bx],al

		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters
	DiskGetDPT          endp

;---------------------------------------------------------------------------
; DiskPutDPT
;---------------------------------------------------------------------------
	DiskPutDPT          proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+08]              ;get item
		mov     si,[bx]

		mov     bx,[bp+06]              ;return item
		mov     al,[bx]

		push    ax
		mov     al,1eh                  ;get old vector
		mov     ah,35h                  ;returned in ES:BX
		int     21h
		pop     ax

		xor     ah,ah
		mov     es:[bx+si],al           ;get item from

		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters
	DiskPutDPT          endp

	code    ends
		end
