	Name    FORMLIB

	Public  IReset,IWrite,IGet,ISet,IFormat

	Title   FORMLIB.ASM

;***************************************************************************
;       CLIPPER VERSION OF MODULE                                    910105
;***************************************************************************
	EXTRN   __RET:FAR
	EXTRN   __RETC:FAR
	EXTRN   __RETCLEN:FAR
	EXTRN   __STORCLEN:FAR
	EXTRN   __RETNI:FAR
	EXTRN   __PARNI:FAR
	EXTRN   __PARC:FAR

;***************************************************************************
;       Data Area
;***************************************************************************
	DGROUP GROUP DATASG

	DATASG SEGMENT '_DATA'

	p1      DB      ?
	p2      DB      ?
	p3      DB      ?
	p4      DB      ?
	p5      DB      ?

	rwSpecialFunctions   DB      ?  ;Read/Write Block IOCTL
	rwHead               DW      ?  ;info structure
	rwCylinder           DW      ?
	FirstSector          DW      ?
	NumberOfSectors      DW      ?
	TransferAddress      DD      ?
	

	fSpecialFunctions    DB      ?  ;Format Block IOCTL
	fHead                DW      ?  ;info structure
	fCylinder            DW      ?
	

	tempstr              DB 100 DUP (0)
	gnu                  DB      '$'   

	DATASG ENDS

;***************************************************************************
;       Code Area
;***************************************************************************
	_PROG segment 'CODE'
	ASSUME cs:_PROG,ds:DGROUP

;---------------------------------------------------------------------------
; IReset
;---------------------------------------------------------------------------
	IReset       proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    es
		push    si
		push    di

		mov     ax,1
		push    ax
		call    __PARNI
		add     sp,2
		mov     ah,00
		int     13h

		mov     al,ah
		xor     ah,ah
		push    ax
		call    __RETNI
		add     sp,2

		pop     di
		pop     si
		pop     es
		pop     ds
		pop     bp                      ;restore old BP
		ret
	IReset       endp

;---------------------------------------------------------------------------
; IWrite
;---------------------------------------------------------------------------
	IWrite     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		push    ds                      ;get sector data
		push    ax                      ;to write to disk
		push    dx
		mov     ax,1
		push    ax
		call    __PARC
		add     sp,02
		push    dx
		pop     es
		push    ax
		pop     bx
		pop     dx
		pop     ax
		pop     ds

		push    es
		push    bx

		mov     ax,2                    ;get track
		push    ax
		call    __parni
		add     sp,2
		mov     p1,al

		mov     ax,3                    ;get head
		push    ax
		call    __parni
		add     sp,2
		mov     p2,al
						;get sector
		mov     ax,4
		push    ax
		call    __parni
		add     sp,2
		mov     p3,al
						;get sector count
		mov     ax,5
		push    ax
		call    __parni
		add     sp,2
		mov     p4,al
						;set regs with 
		mov     dl,p1                   ;values from clipper
		mov     dh,p2
		mov     ch,p3
		mov     cl,p4

		pop     bx
		pop     es

		mov     ax,0301h
		int     13h                     ;call read sector

		jnc     wrt_ok
		jmp     wrt_code
wrt_ok:         xor     ax,ax
wrt_code:       mov     al,ah
		xor     ah,ah

		push    ax                      ;return error value        
		call    __RETNI
		add     sp,2

		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret
	IWrite     endp

;----------------------------------------------------------------------------
; IGet
;----------------------------------------------------------------------------
	IGet        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds

		mov     ax,1                    ;get IOCTL PB
		push    ax
		call    __parc
		add     sp,2

		cld
		push    ds
		push    es
		push    si
		push    di
		
		push    dx
		pop     ds
		push    ax
		pop     si
		mov     di,dgroup
		push    di
		pop     es
		mov     di,word ptr tempstr
		mov     cx,38
		rep     movsb

		pop     di
		pop     si
		pop     es
		pop     ds
						
		mov     ax,2                    ;get drive
		push    ax
		call    __PARNI
		add     sp,2
		xor     ah,ah
		mov     bl,al

		mov     ah,44h                  ;get dev param
		mov     al,0dh                  ;subfunction
		mov     ch,8
		mov     cl,60h

		mov     di,dgroup
		push    di
		pop     ds
		mov     dx,word ptr tempstr

		int     21h

		mov     ax,38
		push    ax
		mov     dx,dgroup
		mov     ax,word ptr tempstr
		push    dx
		push    ax
		call    __retclen               ;return IOCTL PB
		add     sp,6

		pop     ds
		pop     bp                      ;restore old BP
		ret
	IGet        endp
;----------------------------------------------------------------------------
; ISet
;----------------------------------------------------------------------------
	ISet        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    es

		mov     ax,1                    ;get IOCTL PB
		push    ax
		call    __parc
		add     sp,2

		cld
		push    ds
		push    es
		push    si
		push    di
		
		push    dx
		pop     ds
		push    ax
		pop     si
		mov     di,seg tempstr
		push    di
		pop     es
		mov     di,offset tempstr
		mov     cx,90
		rep     movsb

		pop     di
		pop     si
		pop     es
		pop     ds

		mov     ax,2                    ;get drive
		push    ax
		call    __PARNI
		add     sp,2
		xor     ah,ah
		mov     bl,al

		mov     ah,44h                  ;call IOCTL
		mov     al,0dh                  ;set dev param
		mov     ch,8                    ;subfunction
		mov     cl,40h
		mov     di,seg tempstr
		push    di
		pop     ds
		mov     dx,offset tempstr

		int     21h

		pop     es
		pop     ds
		pop     bp                      ;restore old BP
		call    __RET
		ret
	ISet        endp

;----------------------------------------------------------------------------
; IFormat  
;----------------------------------------------------------------------------
	IFormat         proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    es

		mov     ax,1                    ;get track to format
		push    ax
		call    __PARNI
		add     sp,2
		mov     fCylinder,ax

		mov     ax,2                    ;get head to format
		push    ax
		call    __PARNI
		add     sp,2
		mov     fHead,ax

		mov     ax,3                    ;check or format ?
		push    ax
		call    __PARNI
		add     sp,2
		xor     ah,ah
		mov     fSpecialFunctions,al

		mov     ax,4                    ;drive to format
		push    ax
		call    __PARNI
		add     sp,2
		mov     bl,al

		push    ds

		mov     ah,44h                  ;call IOCTL
		mov     al,0dh                  ;format
		mov     ch,8                    ;subfunction
		mov     cl,42h
		mov     di,seg fSpecialFunctions
		push    di
		pop     ds
		mov     dx,offset fSpecialFunctions
		int     21h

		pop     ds

		mov     cl,fSpecialFunctions
		xor     ch,ch                   ;return error value
		push    cx
		call    __RETNI
		add     sp,2

		pop     es
		pop     ds
		pop     bp                      ;restore old BP
		ret
	IFormat     endp

	_PROG ENDS
	END
