	Name    DISK

	Public  IOCTLGet,IOCTLSet,IOCTLFormat,DiskWriteSector

	Title   DISK.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        901228
;***************************************************************************
;* iErrcode% = IOCTLGet% (iDrive%, sDevparam$)    :' sDevparam$=SPACE$(38)
;* iErrcode% = IOCTLSet% (iDrive%, sDevparam$)    :' - " - + Tracklayout
;* iErrcode% = IOCTLFormat% (iDrive%, iSpec%, iHead%, iCylinder%)
;* iErrcode% = IOCTLRead% (iDrive%, iHead%, iCylinder%, iSector%, sSdata$)
;* iErrcode% = IOCTLWrite% (iDrive%, iHead%, iCylinder%, iSector%, sSdata$)
;***************************************************************************

	extrn   STRINGADDRESS:far
	extrn   STRINGLENGTH:far

;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'

	Stringlen       db ?

	strOff  dw      ?               ;string offset  BC7
	strSeg  dw      ?               ;string segment BC7
	StrLen  dw      ?               ;string length  BC7

	rwSpecialFunctions   DB      ?  ;Read/Write Block IOCTL
	rwHead               DW      ?  ;info structure
	rwCylinder           DW      ?
	FirstSector          DW      ?
	NumberOfSectors      DW      ?
	TransferAddress      DD      ?

	fSpecialFunctions    DB      ?  ;Format Block IOCTL
	fHead                DW      ?  ;info structure
	fCylinder            DW      ?



;           SpecialFunctions     DB      ?
;           DeviceType           DB      ?
;           DeviceAttributes     DW      ?
;           NumberOfCylinders    DW      ?
;           MediaType            DB      ?
;           BytesPerSector       DW      ?
;           SectorsPerCluster    DB      ?
;           ReservedSectors      DW      ?
;           NumberOfFATs         DB      ?
;           RootEntries          DW      ?
;           TotalSectors         DW      ?
;           MediaDescriptors     DB      ?
;           SectorsPerFAT        DW      ?
;           SectorsPerTrack      DW      ?
;           Heads                DW      ?
;           HiddenSectors        DD      ?
;           BigTotalSectors      DD      ?
;           Reserved             DB      6 Dup (0)

	data    ends
	dgroup  group   data


;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

;----------------------------------------------------------------------------
; IOCTLGet
;----------------------------------------------------------------------------
	IOCTLGet        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     ax,[bp+06]              ;get string address
		push    ax
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx

		mov     bx,[bp+08]              ;get drive
		mov     bl,[bx]

		mov     ah,44h
		mov     al,0dh
		mov     ch,8
		mov     cl,60h
		mov     dx,strOff
		mov     si,strSeg
		push    ds
		push    si
		pop     ds

		int     21h

		pop     ds
		jc      error0
		xor     ax,ax
error0:

		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     04                      ;return 2xParameters
	IOCTLGet        endp
;----------------------------------------------------------------------------
; IOCTLSet
;----------------------------------------------------------------------------
	IOCTLSet        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     ax,[bp+06]              ;get string address
		push    ax
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx

		mov     bx,[bp+08]              ;get drive
		mov     bl,[bx]

		mov     ah,44h
		mov     al,0dh
		mov     ch,8
		mov     cl,40h
		mov     dx,strOff
		mov     si,strSeg
		push    ds
		push    si
		pop     ds

		int     21h
		pop     ds
		jc      error1
		xor     ax,ax
error1:
		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     04                      ;return 2xParameters
	IOCTLSet        endp

;----------------------------------------------------------------------------
; IOCTLFormat
;----------------------------------------------------------------------------
	IOCTLFormat     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     bx,[bp+06]              ;get cylinder
		mov     cx,[bx]
		mov     fCylinder,cx

		mov     bx,[bp+08]              ;get head
		mov     cx,[bx]
		mov     fHead,cx

		mov     bx,[bp+10]              ;get specialfunc
		mov     cl,[bx]
		mov     fSpecialFunctions,cl

		mov     bx,[bp+12]              ;get drive
		mov     bl,[bx]

		mov     ah,44h
		mov     al,0dh
		mov     ch,8
		mov     cl,42h
		mov     dx,offset dgroup:fSpecialFunctions

		int     21h

		jc      error2
		xor     ax,ax
error2:
		mov     cl,fSpecialFunctions
		mov     bx,[bp+10]              ;get specialfunc
		mov     [bx],cl                 ;return value

		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     08                      ;return 2xParameters
	IOCTLFormat     endp

;---------------------------------------------------------------------------
; DiskWriteSector
;---------------------------------------------------------------------------
	DiskWriteSector     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+06]              ;get string addr in ax
		push    bx
		call    STRINGADDRESS
		mov     es,dx
		mov     bx,ax

		push    bx
		mov     bx,[bp+16]              ;get head nr in dh
		mov     dl,[bx]
		mov     bx,[bp+14]              ;get track nr in ch
		mov     dh,[bx]
		mov     bx,[bp+12]              ;get sector nr in cl
		mov     ch,[bx]
		mov     bx,[bp+10]              ;get al
		mov     cl,[bx]
		pop     bx
		mov     ax,0301h
		int     13h                     ;call read sector

		jnc     wrt_ok
		jmp     wrt_code
wrt_ok:         xor     ax,ax
wrt_code:       mov     al,ah
		xor     ah,ah
		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     12                      ;return 2xParameters
	DiskWriteSector     endp

	code    ends
		end

