;----------------------------------------------------------------------------
;           PRTSWAP.COM - printer output port swap utility
;
;                Created: 881120    Updated: 881129
;                          Timelog: 7 h
;----------------------------------------------------------------------------

code            segment para public 'code'
                assume cs:code
                org 100h

begin:          jmp initialize

column_count    dw ?
setup_status    db 0
display_mode    dw ?
page_no         dw ?

display_table   db 2Dh,29h
video           dw 0B800h,0B900h,0BA00h,0BB00h

mono_video      dw 0B000h

old_kb_int              label dword
old_keyboard_int        dw 2 dup (?)

old_com_int              label dword
old_rs232_int            dw 2 dup (?)

old_lpt_int              label dword
old_centronics_int       dw 2 dup (?)

;---------------------------------------------------------------------------
; Text of printer port swap menu.
; screen_text is the popup menu text to be placed on screen.
; oldscreen_text is the place to put the image under the popup menu.
; ports_text gets changed when ports assigment changes, and gets printed
; every time user presses up or down arrow.
; lpt1_text > com3_text contains inverted text for highlighted port
;---------------------------------------------------------------------------

screen_text     label   word
scr_text        db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07," ",07," ",07," ",07," ",07,"V",07,"",07
                db      "L",07,"J",07," ",07,"S",07,"K",07,"R",07,"I",07
                db      "V",07,"A",07,"R",07,"U",07,"T",07,"G",07,"",07
                db      "N",07,"G",07," ",07,"!",07," ",07," ",07," ",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      "L",07,"P",07,"T",07,"1",07," ",07," ",07,"=",07
                db      ">",07," ",07," ",07,"L",07,"P",07,"T",07,"1",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07,"",07
                db      "",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      "L",07,"P",07,"T",07,"2",07," ",07," ",07,"=",07
                db      ">",07," ",07," ",07,"L",07,"P",07,"T",07,"2",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07,"",07
                db      "",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      "L",07,"P",07,"T",07,"3",07," ",07," ",07,"=",07
                db      ">",07," ",07," ",07,"L",07,"P",07,"T",07,"3",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07,"",07
                db      "",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      "C",07,"O",07,"M",07,"1",07," ",07," ",07,"=",07
                db      ">",07," ",07," ",07,"C",07,"O",07,"M",07,"1",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07,"",07
                db      "",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      "C",07,"O",07,"M",07,"2",07," ",07," ",07,"=",07
                db      ">",07," ",07," ",07,"C",07,"O",07,"M",07,"2",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07,"",07
                db      "",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      "C",07,"O",07,"M",07,"3",07," ",07," ",07,"=",07
                db      ">",07," ",07," ",07,"C",07,"O",07,"M",07,"3",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07,"",07
                db      "",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07,"",07
                db      "",07," ",07,"F",07,"1",07,"=",07,"L",07,"P",07
                db      "T",07,"1",07," ",07," ",07,"F",07,"2",07,"=",07
                db      "L",07,"P",07,"T",07,"2",07," ",07," ",07,"F",07
                db      "3",07,"=",07,"L",07,"P",07,"T",07,"3",07," ",07,"",07
                db      "",07," ",07,"F",07,"5",07,"=",07,"C",07,"O",07
                db      "M",07,"1",07," ",07," ",07,"F",07,"6",07,"=",07
                db      "C",07,"O",07,"M",07,"2",07," ",07," ",07,"F",07
                db      "7",07,"=",07,"C",07,"O",07,"M",07,"3",07," ",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07," ",07," ",07," ",07," ",07," ",07," ",07
                db      " ",07,"E",07,"S",07,"C",07," ",07,"=",07," ",07
                db      "A",07,"v",07,"s",07,"l",07,"u",07,"t",07,"a",07
                db      " ",07," ",07," ",07," ",07," ",07," ",07," ",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07
                db      "",07,"",07,"",07,"",07,"",07,"",07,"",07,"",07

oldscreen_text  label   word
oldscr_text     dw 1024 dup (?)

ports_text      label   word
prts_text       db      "L",07,"P",07,"T",07,"1",07
                db      "L",07,"P",07,"T",07,"2",07
                db      "L",07,"P",07,"T",07,"3",07
                db      "C",07,"O",07,"M",07,"1",07
                db      "C",07,"O",07,"M",07,"2",07
                db      "C",07,"O",07,"M",07,"3",07

lpt1_text       label   word
lpt1_tex        db      "L",112,"P",112,"T",112,"1",112
                db      "L",112,"P",112,"T",112,"2",112
                db      "L",112,"P",112,"T",112,"3",112
                db      "C",112,"O",112,"M",112,"1",112
                db      "C",112,"O",112,"M",112,"2",112
                db      "C",112,"O",112,"M",112,"3",112

lpt1_old        db      "L",07,"P",07,"T",07,"1",07
lpt2_old        db      "L",07,"P",07,"T",07,"2",07
lpt3_old        db      "L",07,"P",07,"T",07,"3",07
com1_old        db      "C",07,"O",07,"M",07,"1",07
com2_old        db      "C",07,"O",07,"M",07,"2",07
com3_old        db      "C",07,"O",07,"M",07,"3",07


lpt1_ptr        db      0
lpt2_ptr        db      1
lpt3_ptr        db      2
com1_ptr        db      3
com2_ptr        db      4
com3_ptr        db      5

current_port    db      0

;---------------------------------------------------------------------------
;Execution comes here, to the main body of the program, when an interrupt 9
;is generated from the keyboard.  Registers are saved, then the keypress is
;checked and compared to the key combination that activates the menu window.
;---------------------------------------------------------------------------

main            proc near
                sti
                push    ax
                push    bx
                push    cx
                push    dx
                push    bp
                push    si
                push    di
                push    ds
                push    es
                pushf                   ;simulate interrupt call to old
                call    old_kb_int      ;old keyboard routine
                mov     ah,2            ;check status of the shift keys
                int     16h
                and     al,5            ;Ctrl and Rt-Shift depressed?
                cmp     al,5
                je      do_program      ;yes, then skip exit routine

;Exit routine is the common point of exit for all routines in the program.

exit:           pop     es
                pop     ds
                pop     di
                pop     si
                pop     bp
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                iret

;Execution comes here when the proper key combination, Ctrl/Rt-Shift, is
;pressed.  First task is to check whether or not the window is already open.

do_program:     push cs                 ;set es and ds to the code segment
                pop ds
                push cs
                pop es
                cmp setup_status,0      ;is the window already open?
                jne exit                ;yes, then ignore request

;---------------------------------------------------------------------------
;Check current video mode.  If it's mode 2, 3, or 7, then set the window
;status flag, store the mode number and page number, save the cursor type,
;and hide the cursor.  If any other display mode is active instead, ignore
;the request and exit.
;---------------------------------------------------------------------------

                mov ah,15               ;get page and mode numbers
                int 10h                 ;al=mode, bh=page
                cmp al,2                ;is crt now in an acceptable mode?
                je prog0                ;yes, then continue
                cmp al,3
                je prog0
                cmp al,7
                je prog0
                jmp exit                ;no, then ignore request
prog0:          mov setup_status,1
                mov ah,0
                mov display_mode,ax
                push bx
                mov bl,bh               ;save page number for color displays
                mov bh,0
                mov page_no,bx
                pop bx

;Preparatory routines are completed.  Now open the window by first saving the
;contents or video memory beneath the window and the writing the window text
;directly to memory.

                mov     bx,page_no
                cmp     display_mode,7
                jne     prog1
                mov     bx,4
prog1:          shl     bx,1
                mov     ax,video[bx]
                mov     ds,ax
                cmp     display_mode,7
                je      prog2
                call    video_disable
prog2:          lea     di,oldscreen_text
                mov     ch,29               ;define window dimensions and location
                mov     cl,15
                mov     dh,5
                mov     dl,24
                call    video2mem
                push    ds                 ;set es to video memory
                pop     es
                push    cs                 ;reset ds to code segment
                pop     ds
                lea     si,screen_text
prog3:          mov     ch,29               ;define window region
                mov     cl,15
                mov     dh,5
                mov     dl,24
                call    mem2video
                call    update_screen
                cmp     display_mode,7
                je      getkey
                call    video_enable

;----------------------------------------------------------------------------
; getkey:
; Here we wait for a keypress an processes it.
;----------------------------------------------------------------------------

getkey:         mov     ah,0                    ;get keypress
                int     16h
                cmp     al,27
                jne     prg_99
                jmp     exit_key_pressed        ;its ESCape
prg_99:         cmp     ah,72
                je      key_up                  ;its key up
                cmp     ah,80
                je      key_down                ;its key down
                mov     al,0
                cmp     ah,59
                je      key_port                ;its F1
                mov     al,1
                cmp     ah,60
                je      key_port                ;its F2
                mov     al,2
                cmp     ah,61
                je      key_port                ;its F3
                mov     al,3
                cmp     ah,63
                je      key_port                ;its F5
                mov     al,4
                cmp     ah,64
                je      key_port                ;its F6
                mov     al,5
                cmp     ah,65
                je      key_port                ;its F7

                mov     ax,2000                 ; no valid key,
                call    beep                    ; beep to tell the user
                jmp     getkey

;----------------------------------------------------------------------------
; Check up and down arrow and update acording to changes.
;----------------------------------------------------------------------------

key_up:         mov     ah,cs:current_port
                cmp     ah,0
                je      key_update_port
                dec     ah
		mov     cs:current_port,ah
                jmp     key_update_port

key_down:       mov     ah,cs:current_port
                cmp     ah,5
                je      key_update_port
                inc     ah
		mov     cs:current_port,ah
                jmp     key_update_port

key_update_port:
                call    update_screen
                jmp     getkey

;----------------------------------------------------------------------------
; key_port
; Here we update the interupt assigment variables and changes
; the text on screen to new port assignments.
;----------------------------------------------------------------------------
key_port:       push    ax                      ;save for inverted
                xor     bx,bx                   ;clear bx
		mov     bl,cs:current_port      ;get current port
		lea     bp,cs:lpt1_ptr          ;let bp point to port_ptr
                add     bp,bx                   ;add current port nr.
		mov     cs:[bp],al              ;put outputport there
                xor     ah,ah                   ;clear high order
                rol     al,1                    ;al=al*8
                rol     al,1
                rol     al,1
		lea     si,cs:lpt1_old          ;si points to lpt1_old
                add     si,ax                   ;add to right port_old
                xor     bh,bh                   ;clear high order
                rol     bl,1                    ;bl=bl*8
                rol     bl,1
                rol     bl,1
                push    es                      ;save es (video segment)
                push    ds                      ;set es=ds
                pop     es
		lea     di,ports_text           ;dest points to ports_text
                add     di,bx                   ;add to ports_current
                mov     cx,4                    ;and
                repz    movsw                   ;move port text
                pop     es                      ;restore es (video segment)
; do the same with the inverted screen image
                pop     ax                      ;restore port setting
                xor     bx,bx                   ;clear bx
                mov     bl,current_port         ;get current port
                xor     ah,ah                   ;clear high order
                rol     al,1                    ;al=al*8
                rol     al,1
                rol     al,1
                lea     si,lpt1_old             ;si points to lpt1_old
                add     si,ax                   ;add to right port_old
                xor     bh,bh                   ;clear high order
                rol     bl,1                    ;bl=bl*8
                rol     bl,1
                rol     bl,1
                push    es                      ;save es (video segment)
                push    ds                      ;set es=ds
                pop     es
                lea     di,lpt1_text            ;dest points to ports_text
                add     di,bx                   ;add to ports_current
                mov     cx,4                    ;and
prg_98:         lodsw
                mov     ah,112                  ;change attribute
                stosw                           ;move port text
                loop    prg_98
                pop     es                      ;restore es (video segment)

                call    update_screen           ; update screen
                jmp     getkey

;---------------------------------------------------------------------------
; update_screen
;
;
;
;---------------------------------------------------------------------------
update_screen:  push    cs                 ;reset ds to code segment
                pop     ds
; Print all the ports to clean videomemory
                lea     si,ports_text
                mov     ch,4                    ;define window region
                mov     cl,6
                mov     dh,8
                mov     dl,41
                call    mem2video
; Print inverted port to screen
                xor     ax,ax
                mov     al,current_port
                push    ax
                lea     si,lpt1_text            ;let si point to port_text
                rol     al,1                    ; al=al*8
                rol     al,1
                rol     al,1
                add     si,ax                   ;si points to port_text
                pop     ax
                mov     ch,4
                mov     cl,1
                mov     dh,8
                add     dh,al
                mov     dl,41
                call    mem2video

                ret

;---------------------------------------------------------------------------
;Execution comes here when the ESC key is pressed.  The window is refilled
;with its original contents, the cursor is restored, and control is handed
;back to the application program.
;---------------------------------------------------------------------------

exit_key_pressed:
                cmp     display_mode,7
                je      prog4
                call    video_disable
prog4:          lea     si,oldscreen_text
                mov     ch,29               ;define the window
                mov     cl,15
                mov     dh,5
                mov     dl,24
                call    mem2video
                cmp     display_mode,7
                je      prog5
                call    video_enable
prog5:          mov     setup_status,0      ;reset window status
                jmp     exit                ;and exit

main            endp

;---------------------------------------------------------------------------
;com_prg
;Handles communications port interrupt (INT14)
;---------------------------------------------------------------------------
com_prg         proc near
		sti                     ;reenable interupts
		push bx                 ;save registers
		push cx
		push dx
		push si
		push di
		push ds
		push es

		cmp  dx,0               ;is com1 requested
		jne  com_2              ;no, check com2
		cmp  com1_ptr,3         ;does com1 point to com1
		jz   com_go
		cmp  com1_ptr,2         ;does com1 point to com2/com3
		jle  com_lpt            ;no, then lptx
		xor  dx,dx
		mov  dl,com1_ptr        ;add printer number to dx
		sub  dl,3               ;make null-based
		jmp  com_go             ;and do old INT 14H


com_2:          cmp  dx,1               ;is com2 requested
		jne  com_3              ;no, then com3
		cmp  com2_ptr,4         ;does com2 point to com2
		jz   com_go
		cmp  com2_ptr,2         ;does com2 point tp com1/com3
		jle  com_lpt            ;no, then lptx
		xor  dx,dx
		mov  dl,com2_ptr        ;add printer number to dx
		sub  dl,3               ;make null-based
		jmp  com_go             ;and do old INT 14H

com_3:          cmp  com3_ptr,5         ;does com3 point to com3
		jz   com_go
		cmp  com3_ptr,2         ;does lpt3 point to com1/com2
		jle  com_lpt            ;no, then lptx
		xor  dx,dx
		mov  dl,com3_ptr        ;add printer number to dx
		sub  dl,3               ;make null-based
		jmp  com_go             ;and do old INT 14H

com_go:         pushf                   ;simulate interrupt call
		call old_com_int
com_exit:       pop es
		pop ds
		pop di
		pop si
		pop dx
		pop cx
		pop bx
		iret


;---------------------------------------------------------------------------
;lpt_com
;Handles parallel port => serial port conversion
;---------------------------------------------------------------------------

com_lpt:        jmp     com_go




com_prg         endp

;---------------------------------------------------------------------------
;lpt_prg
;Handles parallel port interrupt (INT17)
;---------------------------------------------------------------------------
lpt_prg         proc near
		sti                     ;reenable interupts
		push bx                 ;save registers
		push cx
		push dx
		push si
		push di
		push ds
		push es

		cmp  dx,0               ;is lpt1 requested
		jne  lpt_2              ;no, check lpt2
		cmp  lpt1_ptr,0         ;does lpt1 point to lpt1
		jz   lpt_go
		cmp  lpt1_ptr,2         ;does lpt1 point to lpt2/lpt3
		jg   lpt_com            ;no, then comx
		xor  dx,dx
		mov  dl,lpt1_ptr        ;add printer number to dx
		jmp  lpt_go             ;and do old INT 17H

lpt_2:          cmp  dx,1               ;is lpt2 requested
		jne  lpt_3              ;no, then lpt3
		cmp  lpt2_ptr,1         ;does lpt2 point to lpt2
		jz   lpt_go
		cmp  lpt2_ptr,2         ;does lpt2 point tp lpt1/lpt3
		jg   lpt_com            ;no, then comx
		xor  dx,dx
		mov  dl,lpt2_ptr        ;add printer number to dx
		jmp  lpt_go             ;and do old INT 17H

lpt_3:          cmp  lpt3_ptr,2         ;does lpt3 point to lpt3
		jz   lpt_go
		cmp  lpt3_ptr,2         ;does lpt3 point to lpt1/lpt2
		jg   lpt_com            ;no, then comx
		xor  dx,dx
		mov  dl,lpt3_ptr        ;add printer number to dx
		jmp  lpt_go             ;and do old INT 17H

lpt_go:         pushf                   ;simulate interrupt call
		call old_lpt_int
lpt_exit:       pop es
		pop ds
		pop di
		pop si
		pop dx
		pop cx
		pop bx
		iret
lpt_prg         endp


;---------------------------------------------------------------------------
;lpt_com
;Handles parallel port => serial port conversion
;---------------------------------------------------------------------------

lpt_com         proc    far
		cmp  dx,0               ;is lpt1 requested
		jne  lc_2               ;no, check lpt2

		xor  dx,dx
		mov  dl,lpt1_ptr        ;add printer number to dx
		dec  dx                 ;adjust dx for com
		dec  dx
		dec  dx
		jmp  lc_go              ;and do old INT 17H

lc_2:           cmp  dx,1               ;is lpt2 requested
		jne  lc_3               ;no, then lpt3
		xor  dx,dx
		mov  dl,lpt2_ptr        ;add printer number to dx
		dec  dx                 ;adjust dx for com
		dec  dx
		dec  dx
		jmp  lc_go              ;and do old INT 17H

lc_3:           xor  dx,dx              ;does lpt3 point to lpt3
		mov  dl,lpt3_ptr        ;add printer number to dx
		dec  dx                 ;adjust dx for com
		dec  dx
		dec  dx
		jmp  lc_go              ;and do old INT 17H

lc_go:          cmp     ah,00
		je      lpt_com_00
		cmp     ah,01
		je      lpt_com_01
		cmp     ah,02
		je      lpt_com_02
		jmp     com_go

lpt_com_00:     mov     ah,01           ;print character     (AH=00)
		pushf
		call    old_com_int
					;check and convert error code

		jmp     lpt_exit

lpt_com_01:     mov     ah,03           ;initialize printer  (AH=01)
		pushf
		call    old_com_int
					;check and convert error code

		jmp     lpt_exit

lpt_com_02:     mov     ah,03           ;read printer status (AH=02)
		pushf
		call    old_com_int
					;check and convert error code

		jmp     lpt_exit
lpt_com         endp


;---------------------------------------------------------------------------
;VIDEO_ENABLE and VIDEO_DISABLE routines manipulate bit 3 of port 3D8h,
;the CGA Mode Control Register, to temporarily turn the display on or off.
;Since these routines write directly to hardware, they have no effect on
;other video adapters.
;---------------------------------------------------------------------------

video_disable   proc near
                mov dx,3DAh             ;read CGA status port
disable1:       in al,dx                ;wait for vertical retrace to occur
                test al,8               ;is bit 3 set?
                je disable1             ;no, wait until it is
                mov dx,3D8h             ;now disable the display
                mov     al,25h          ;by clearing bit 3 of Mode Control Register
                out dx,al
                ret
video_disable   endp

video_enable    proc near
                mov dx,3D8h             ;CGA Mode Control Register
                mov bx,display_mode     ;get value to re-enable display
                sub bx,2
                mov al,display_table[bx]
                out dx,al               ;and send it to the port
                ret
video_enable    endp

;---------------------------------------------------------------------------
;VIDEO2MEM routine transfers the contents of a portion of video memory
;to a memory buffer for storage.
;Entry:         DS    - video segment
;               ES:DI - memory buffer
;               DH,DL - row and column of upper left corner of window
;               CH    - width of window in columns
;               CL    - number of lines in window
;---------------------------------------------------------------------------

video2mem       proc near
                mov al,ch
                mov ah,0
                mov column_count,ax
                mov ch,0
                push di
                call video_offset
                mov si,di
                pop di
v2mem1:         push si
                push cx
                mov cx,column_count
                call writeln
                pop cx
                pop si
                add si,160
                loop v2mem1
                ret
video2mem       endp

;---------------------------------------------------------------------------
;MEM2VIDEO writes a selected area of memory to the video display.
;Entry:         DS:SI - memory buffer
;               ES    - video segment
;               DH,DL - row and column of upper left corner of window
;               CH    - width of window in columns
;               CL    - number of lines in window
;---------------------------------------------------------------------------

mem2video       proc near
                mov al,ch
                mov ah,0
                mov column_count,ax
                mov ch,0
                call video_offset
mem2v1:         push di
                push cx
                mov cx,column_count
                call writeln
                pop cx
                pop di
                add di,160
                loop mem2v1
                ret
mem2video       endp

;---------------------------------------------------------------------------
;VIDEO_OFFSET calculates the offset into video memory of a character cell.
;Entry:         DH,DL - row and column of cell (0-24,0-79)
;Exit:          DI    - offset address
;---------------------------------------------------------------------------

video_offset    proc near
                mov al,160
                mul dh                  ;row * 160
                shl dl,1                ;column * 2
                mov dh,0                ;byte to word
                add ax,dx               ;(row *160)+(column*2)
                mov di,ax               ;set offset in di
                ret
video_offset    endp

;---------------------------------------------------------------------------
;WRITELN subroutine copies a string of words from one memory location to
;another.  The CGA status port is not checked for vertical retrace status
;before transter.
;Entry:         DS:SI - source
;               ES:DI - destination
;               CX    - number of words
;---------------------------------------------------------------------------

writeln         proc near
                cld
write1:         movsw
                loop write1
                ret
writeln         endp

;---------------------------------------------------------------------------
;LPRINTZ routine sends a string of bytes delimited by a user-specified byte to
;LPT1: thru INT 17h.
;Entry:         DS:SI - string address
;               BL    - delimiter (0-255)
;---------------------------------------------------------------------------

lprintz         proc near
                cld
lprintz1:       lodsb                   ;get one byte
                cmp al,bl               ;is it the delimiter?
                je lprintz2             ;yes, then exit
                mov dx,0                ;printer no 0. (LPT1:)
                mov ah,0
                int 17h                 ;send byte to printer
                jmp lprintz1            ;return for next byte
lprintz2:       ret
lprintz         endp

;---------------------------------------------------------------------------
;LPT1STAT checks the current status of printer LPT1:.  If it's either
;powered off or off-line, then an error condition is signalled upon return
;thru the carry flag.
;Exit:          Carry clear - no error
;               Carry set   - error
;---------------------------------------------------------------------------

lpt1stat        proc near
                mov dx,0                ;printer no. 0
                mov ah,2                ;use ROM BIOS 'get status' function
                int 17h
                test ah,8               ;test bit 3, I/O error indicator
                je stat1                ;if clear, then no error
                stc
                ret
stat1:          clc
                ret
lpt1stat        endp

;---------------------------------------------------------------------------
;BEEP uses the 8253 timer chip to emit a short beep thru the PC's speaker.
;---------------------------------------------------------------------------

beep            proc near
                mov al,182      ;notify 8253 that frequence data is coming
                out 67,al
                mov al,0                ;send frequency (776.8 Hz)
                out 66,al
                mov al,6
                out 66,al
                in al,97                ;activate speaker
                or al,3
                out 97,al
                mov cx,6000h            ;time delay for sound duration
beep1:          loop beep1
                in al,97                ;deactivate speaker
                and al,252
                out 97,al
                ret
beep            endp

;---------------------------------------------------------------------------
;MEM2MEM subroutine transfers a non-overlapping block of memory one byte
;at a time.
;Entry:         DS:SI - source
;               ES:DI - destination
;               CX    - number of bytes
;---------------------------------------------------------------------------

mem2mem         proc near
                cld
mem1:           movsb
                loop mem1
                ret
mem2mem         endp

;---------------------------------------------------------------------------
;Initialization routine sets up the window image in the WINDOW_TEXT area,
;resets the CURSOR_MODE word if this is a PCjr, and saves and replaces the
;old keyboard interrupt vector.
;---------------------------------------------------------------------------

initialize      proc near
                push    cs                      ;set ds=cs
                pop     ds
                mov     al,9                    ;get old vector for
                mov     ah,35h                  ;keyboard interrupt
                int     21h
                mov     old_keyboard_int,bx     ;save old keyboard
                mov     old_keyboard_int[2],es  ;interrupt vector
                mov     dx,offset main          ;set new keyboard
                mov     al,9
                mov     ah,25h
                int     21h

                mov     al,14h                  ;get old vector for
                mov     ah,35h                  ;serial interrupt
                int     21h
                mov     old_rs232_int,bx        ;save old serial
                mov     old_rs232_int[2],es     ;interrupt vector
                mov     dx,offset com_prg       ;set new serial
                mov     al,14h
                mov     ah,25h
                int     21h

                mov     al,17h                  ;get old vector for
                mov     ah,35h                  ;parallell interrupt
                int     21h
                mov     old_centronics_int,bx     ;save old parallell
                mov     old_centronics_int[2],es  ;interrupt vector
		mov     dx,offset lpt_prg          ;set new parallell
                mov     al,17h
                mov     ah,25h
                int     21h

                mov     dx,offset message       ;tell user that program
                mov     ah,09h                  ;is installed
                int     21h

                mov     dx,offset initialize    ;point dx to end of resident section
                int     27h                     ;terminate-but-stay-resident
initialize      endp

message:        db 'PRTSWAP 0.50 - Byt skrivarutgng.',0dh,0ah
                db 0dh,0ah
                db 'Anropa med Ctrl-Hger Shifttangent.$'

code            ends
                end begin

