		TITLE   erik.asm
_TEXT           SEGMENT BYTE    PUBLIC  'CODE'
_TEXT           ENDS

_DATA           SEGMENT WORD    PUBLIC  'DATA'
_DATA           ENDS

CONST           SEGMENT         WORD    PUBLIC  'CONST'
CONST           ENDS
_BSS            SEGMENT WORD    PUBLIC  'BSS'
_BSS            ENDS

DGROUP          GROUP   CONST, _BSS, _DATA
		ASSUME  CS: _TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP


_TEXT           SEGMENT

		PUBLIC  _sound
		PUBLIC  _play
		PUBLIC  _window
		PUBLIC  _no_window

;******************************************************************
;***  Rutin:  Sound      Format: sound (frequency,timeloop)     ***
;******************************************************************

_sound          PROC    NEAR

		push   bp              ; Standard programinledning
		mov    bp,sp           ;
		push   di              ;
		push   si              ;



		mov    bx,[bp+4]       ; Hmta frekvens
		mov    dx,[bp+6]       ; Hmta tonlngd

		in     al,61h          ; Hmta PB register.
		or     al,3            ; Stt 'HGTALARE DATA' och
		out    61h,al          ; 'TIMER GRIND 2' bitarna.
		mov    al,0b6h         ;  
		out    43h,al          ;  
		mov    al,bl           ;   Ladda in frekvens i
		out    42h,al          ;   dator klocka nr. 2.
		mov    al,bh           ;  
		out    42h,al          ;  

sound_begin:    cmp    dx,00           ;  
		jz     sound_slut      ;  
		mov    cx,10           ;   Utfr tonlngsloop
sound_loop:     loop   sound_loop      ;  
		dec    dx              ;  
		jmp   short sound_begin;  

sound_slut:     in     al,61h          ;  Stnger av hgtalare och
		sub    al,3            ;  timer 2.
		out    61h,al          ;

		pop     si             ;
		pop     di             ;
		mov     sp,bp          ; Standard avslutning
		pop     bp             ;
		ret                    ;

_sound          ENDP

;******************************************************************
;***                                                            ***
;***  Routine:  Play    Format: Play (pointer to string,tempo)  ***
;***                                                            ***
;******************************************************************
;
_play           PROC    NEAR
		push   bp                   ; Standard inledning
		mov    bp,sp
		push   di
		push   si
		jmp    short play_para
 ; --------------Playdata---------------

		FREKVENS_TAB    dw   36488, 32502, 28960, 27335, 24350 ;oct 0
				dw   21694, 19325
				dw   18241, 16251, 14478, 13666, 12175 ;oct 1
				dw   10847,  9663
				dw   9121,  8126,  7239,  6833,   6087 ;oct 2
				dw   5423,  4831
				dw   4560,  4063,  3619,  3416,   3043 ;oct 3
				dw   2711,  2415
				dw   2280,  2031,  1809,  1708,   1521 ;oct 4
				dw   1355,  1207
				dw   1140,  1015,   898,   854,    760 ;oct 5
				dw    677,   603
				dw    570,   507,   452,   427,    380 ;oct 6
				dw    338,   301
		TWO             db   02        ; Multiplicera med tw
		FOURTEEN        db   14        ; Multiplicera med fjorton
		OCTAVE          dw   00        ; Adderas till FREKVENS_TAB
		TEMPO           dw   0000      ; TEMPO r hastigheten
		TUNE_TYPE       dw   0000      ; TUNE_TYPE tonlngden


play_para:      mov   si,[bp+4]        ; Pekare till teckenstrng.
		mov   dx,[bp+6]        ; Hmta TEMPO.
		mov   TEMPO,dx         ; Spara TEMPO.
		mov   TUNE_TYPE,dx     ; Stt  helnot.
play_next:      mov   al,[si]          ; Hmta frsta tecknet.
		inc   si               ; ka pekaren.
		or    al,32            ; Gr om till sm bokstver.
		cmp   al,32            ; r tecknet ett mellanslag ?
		jz    play_next        ; Ja, hmta nsta tecken.
		cmp   al,112           ; r tecknet ett 'P' ?
		jz    play_get_value   ; Ja, hoppa till not kodning.
		cmp   al,'o'           ; r tecknet ett 'O' ?
		jz    play_set_oct     ; Ja, stt oktav.
		cmp   al,96            ; r tecknet mindre n 'A' ?
		jna   play_end         ; Ja, avsluta.
		cmp   al,104           ; r tecknet strre n 'B' ?
		ja    play_end         ; Ja, avsluta.
		jmp   short play_get_value   ; Hoppa till not kodning.
play_set_oct:
		mov   al,[si]          ; Hmta nsta tecken.
		cmp   al,47            ; r det mindre n 0 ?
		jna   play_next        ; Ja, hmta nytt tecken.
		cmp   al,55            ; r det strre n 6 ?
		ja    play_next        ; Ja, hmta nytt tecken.
		sub   al,'0'           ; Gr om asciinummer till hexnummer.
		mov   ah,00            ; Nollstll highbyte.
		mul   fourteen      ; Rkna ut tabellvrde.
		mov   cs:OCTAVE,ax     ; Spara vrdet.
		inc   si               ; ka pekaren.
		jmp   short play_next  ; Hmta nsta tecken.
play_no_tune:   mov   cx,150           ; Loop fr att korrigera
play_no_tunelp: loop  play_no_tunelp   ; OUTAR m.m.
		mov   dx,cs:TUNE_TYPE  ; Hmta tonlngd.
play_no_tuneb:  cmp   dx,00            ; r tonlngen slut ?
		jz    play_next        ; Ja, hmta nytt tecken.
		mov   cx,10            ; Gr en liten frdrjnings
play_no_tunel:  loop   play_no_tunel   ; loop.
		dec    dx              ; Rkna ner ton_lngden.
		jmp   short play_no_tuneb    ; Gr om loopen.
play_end:       jmp    play_finished    ; Mellanhand.
play_get_value: push  ax               ; Spara tecknet p stacken.
		mov   ax,[si]          ; Hmta tv nya tecken.
		mov   cl,4             ; Stt shiftrknare till 4.
		cmp   ax,'61'          ; Motsvarar tecknen sextondelsnot.
		jz    play_set_six     ; Ja, hoppa till stt sextondelsnot.
		mov   cl,0             ; Stt shiftrknare till 0.
		cmp   al,'1'           ; r frsta tecknet helnot.
		jz    play_set_type    ; Ja, hoppa till stt_not_typ.
		inc   cl               ; ka shiftrknaren.
		cmp   al,'2'           ; r frsta tecknet halvnot.
		jz    play_set_type    ; Ja, hoppa till stt_not_typ.
		inc   cl               ; ka shiftrknaren.
		cmp   al,'4'           ; r frsta tecknet kvartsnot.
		jz    play_set_type    ; Ja, hoppa till stt_not_typ.
		inc   cl               ; ka shiftrknaren.
		cmp   al,'8'           ; r frsta tecknet ttondelsnot.
		jz    play_set_type    ; Ja, hoppa till stt_not_typ.
		pop   ax               ; terhmta tecknet frn stacken.
		jmp   short play_xchg_test   ; Hoppa till omvandlingstest.
play_set_six:   inc   si               ; ka pekaren.
play_set_type:  inc   si               ; ka pekaren.
		mov   ax,TEMPO         ; Hmta TEMPO.
		shr   ax,cl            ; Rkna ut tonlngd.
		mov   TUNE_TYPE,ax     ; Spara tonlngden.
		pop   ax               ; Hmta gammalt tecken frn stacken.
		jmp   short play_xchg_test   ; Hoppa till omvandlingstest.
play_xchg_test: cmp   al,112           ; r tecknet ett 'p' ?
		jz    play_no_tune     ; Ja, hoppa till igen_ton.
		cmp   al,'a'           ; r tecknet ett 'a' ?
		jz    play_xchg_a      ; Ja, hoppa till byt_ut_a.
		cmp   al,'b'           ; r tecknet ett 'b' ?
		jz    play_xchg_b      ; Ja, hoppa till byt_ut_b.
		jmp   short play_set         ; Inget att byta ut.
play_xchg_a:    mov   al,'h'           ; Erstt 'a' med 'h'.
		jmp   short play_set         ; Hoppa till frekvensutrkning.
play_xchg_b:    mov   al,'i'           ; Erstt 'b' med 'i'.
play_set:       sub   al,'c'           ; Omvandla asciibokstver till tal.
		mov   ah,00            ; Nollstll highbyte.
		mul   two           ; Rkna ut offset i tabell.
		mov   bx,offset cs:FREKVENS_TAB    ; Hmta tabellstart.
		add   bx,ax            ; Addera offset till tabell.
		add   bx,cs:OCTAVE     ; Addera oktavstart till tabell.
		mov   bx,cs:[bx]       ; Hmta innehll i tabell.
		mov   dx,cs:TUNE_TYPE  ; Hmta tonlngden.

play_out_begin: in     al,61h          ; Hmta PB register.
		or     al,3            ; Stt 'HGTALARE DATA' och
		out    61h,al          ; 'TIMER GRIND 2' bitarna.
		mov    al,0b6h         ;  
		out    43h,al          ;  
		mov    al,bl           ;   Ladd in frekvens i
		out    42h,al          ;   dator klocka nr. 2.
		mov    al,bh           ;  
		out    42h,al          ;  

play_begin:     cmp    dx,00           ;  
		jz     short play_slut ;  
		mov    cx,10           ;   Utfr tonlngdsloop.
play_loop:      loop   play_loop       ;  
		dec    dx              ;  
		jmp    short play_begin;  

play_slut:      in     al,61h          ;
		sub    al,3            ; Stng av HGTALARE och klocka 2
		out    61h,al          ;

		mov    cx,5000         ;
play_loopen:    loop   play_loopen     ; Liten pause s att inte flera
		jmp    play_next       ; toner blir en

play_finished:  pop     si             ;
		pop     di             ;
		mov     sp,bp          ; Standard avslutning
		pop     bp             ;
		ret                    ;


_play           ENDP

;****************************************************************************
;*
;*
;*
;****************************************************************************

_window         proc   near
		push   bp              ; Standard inledning
		mov    bp,sp
		push   di
		push   si
		jmp    window_begin

ROW             Dw      00             ; Frsta raden.
COL             Dw      00             ; Frsta kolumnen.
LAST_ROW        Dw      00             ; Sista raden.
LAST_COL        Dw      00             ; Sista kolumnen.
WUL             Db      213            ; Tecknet i vnster-upp hrnet.
WUR             Db      184            ; Tecknet i hger-upp hrnet.
WDL             Db      212            ; Tecknet i vnster-ner hrnet.
WDR             Db      190            ; Tecknet i hger-ner hrnet.
WDX1            Db      205            ; Tecknet i linje x1.
WDX2            Db      205            ; Tecknet i linje x2.
WDY1            Db      179            ; Tecknet i linje y1.
WDY2            Db      179            ; Tecknet i linje y2.
ATTRIBUT        Db       07            ; Teckenattribut
HUNDREDSIXTY    Dw      160            ; Tal
FOURTHOUSEND    dw      4000           ; Tal
SCREEN_AREA     dw      00             ; Pekare till skrmstrng
SCREEN_WIDTH    db      00             ; 40 eller 80 kolumn
SCREEN_MODE     db      00             ; Skrmmodet
SCREEN_PAGE     dw      00             ; Sidan * 4000

WINDOW_BEGIN:   mov     di,[bp+4]
		mov     cs:SCREEN_AREA,di ; Brjan av SCREEN_AREA.
		mov     ax,[bp+6]         ; Hmta frsta raden.
		sub     ax,1              ; Lgg till ett.
		mov     cs:COL,ax         ; Lgg den i ROW.
		mov     [di],ax           ; Lgg del i SCREEN_AREA.
		add     di,2              ; ka SCREEN_AREA.
		mov     ax,[bp+10]        ; Hmta sista raden.
		sub     ax,1              ; Lgg till ett.
		mov     cs:LAST_COL,ax    ; Lgg del i ADD_ROW.
		mov     [di],ax           ; Lgg den i SCREEN_AREA.
		add     di,2              ; ka SCREEN_AREA.
		mov     ax,[bp+8]         ; Hmta frsta kolumnen.
		sub     ax,1              ; Lgg till ett.
		mov     cs:ROW,ax         ; Lgg den i COL.
		mov     [di],ax           ; Lgg den i SCREEN_AREA.
		add     di,2              ; ka SCREEN_AREA.
		mov     ax,[bp+12]        ; Hmta sista kolumnen.
		sub     ax,1              ; Lgg till ett.
		mov     cs:LAST_ROW,ax    ; Lgg den i ADD_COL.
		mov     [di],ax           ; Lgg den i SCREEN_AREA.
		add     di,2              ; ka SCREEN_AREA.
		mov     ax,[bp+14]        ; Hmta kontrollkod.
		cmp     ax,-1             ; r den -1 ?
		jz      window_para       ; Ja, hmta fler parametrar.
		jmp     window_seg        ; Nej,hoppa till segment sttningen.
window_para:    mov     al,[bp+16]        ; Hmta vnster-upp tecknet.
		mov     cs:WUL,al         ; Lgg det i WUL.
		mov     al,[bp+18]        ; Hmta hger-upp tecknet.
		mov     cs:WUR,al         ; Lgg det i WUR.
		mov     al,[bp+20]        ; Hmta vnster-ner tecknet.
		mov     cs:WDL,al         ; Lgg det i WDL.
		mov     al,[bp+22]        ; Hmta hger-ner tecknet.
		mov     cs:WDR,al         ; Lgg det i WDR.
		mov     al,[bp+24]        ; Hmta linje X1 tecknet.
		mov     cs:WDX1,al        ; Lgg det i WDX1.
		mov     al,[bp+26]        ; Hmta linje X2 tecknet.
		mov     cs:WDX2,al        ; Lgg det i WDX2.
		mov     al,[bp+28]        ; Hmta linje Y1 tecknet.
		mov     cs:WDY1,al        ; Lgg det i WDY1.
		mov     al,[bp+30]        ; Hmta linje Y2 tecknet.
		mov     cs:WDY2,al        ; Lgg det i WDY2.
		mov     al,[bp+32]        ; Hmta attribut.
		mov     cs:ATTRIBUT,al    ; Lgg det i ATTRIBUT.

window_seg:     mov     ah,15             ; Kalla screenstatus
		int     10h               ;         "
		mov     cs:SCREEN_MODE,al ; Spara mode i SCREEN_MODE.
		push    ax                ; Spara AX
		mov     ah,00             ; Nollstll highbyte.
		mov     al,bh             ; Flytta BH - AL.
		mul     FOURTHOUSEND      ; Rkna ut sidoffset.
		mov     cs:SCREEN_PAGE,ax ; Spara det i SCREEN_PAGE
		pop     ax                ; tervinn AX
		mov     al,ah             ; Flytta AH - AL.
		mov     ah,00             ; Nollstll highbyte.
		mul     TWO               ; Gr redo fr attribut.
		mov     cs:SCREEN_WIDTH,al; Lgg det i SCREEN_WIDTH.

		mov     ax,0b000h         ; Stt til Monokromskrmminne.
		cmp     cs:SCREEN_MODE,07 ; r det monokromskrm ?
		jz      window_set_seg    ; Ja, stt ES till Monoskrmminne.
		cmp     cs:SCREEN_MODE,04 ; r det grafikmode ?
		jna     window_continue   ; Nej.
		jmp     window_end        ; Ja, avbryt rutin.
window_continue:add     ax,0800h          ; Nej, stt CGA-skrmminne.
window_set_seg: push    ax                ; Spara AX.
		pop     es                ; Ta tillbaka i ES.

		mov     cx,cs:ROW         ; Hmta en rad.
window_save:    mov     bx,cs:COL         ; Hmta en kolumn.
window_sv:      call    window_offset     ; Rkna ut skrmoffset.
		mov     ax,es:[si]        ; Hmta frn skrmminnet.
		mov     [di],ax           ; Lgg i SCREEN_AREA.
		add     di,2              ; ka SCREE_AREA.
		cmp     bx,cs:LAST_COL    ; r det sista kolumnen ?
		jz      window_next_row   ; Ja, hmta ny rad..
		inc     bx                ; Nej, nsta kolumn.
		jmp     window_sv         ; Hoppa till offsetutrkning.
window_next_row:cmp     cx,cs:LAST_ROW    ; r det sista raden ?
		jz      window_rensa      ; Ja, hoppa till rensa fnster.
		inc     cx                ; Nej, nsta rad.
		jmp     window_save       ; Hoppa till kolumnhmtning.

window_rensa:   mov     cx,cs:ROW         ; Hmta en rad.
window_clear:   mov     bx,cs:COL         ; Hmta en kolumn.
window_cl:      call    window_offset     ; Rkna ut skrmoffset.
		mov     ah,07             ; Stt attribut till normalt.
		mov     al,32             ; Stt tecken till mellanslag.
		mov     es:[si],ax        ; Skriv tecknet.
		inc     bx                ; ka kolumn.
		cmp     bx,cs:LAST_COL    ; r det sista kolumnen ?
		jnz     window_cl         ; Nej, hmta ny.
		inc     cx                ; Ja, ka raden.
		cmp     cx,cs:LAST_ROW    ; r det sista raden ?
		jnz     window_clear      ; Nej, hmta ny rad.

		mov     cx,cs:ROW         ; Hmta raden.
		mov     bx,cs:COL         ; Hmta kolumnen.
		call    window_offset     ; Rkna ut skrmoffset.
		mov     al,cs:WUL         ; Hmtar tecken frn WUL.
		mov     ah,cs:ATTRIBUT    ; Hmta attribut.
		mov     es:[si],ax        ; Skriv tecknet.

		mov     cx,cs:LAST_ROW    ; Hmta raden.
		mov     bx,cs:COL         ; Hmta kolumnen.
		call    window_offset     ; Rkna ut skrmoffset.
		mov     al,cs:WDL         ; Hmta tecken frn WDL.
		mov     ah,cs:ATTRIBUT    ; Hmta attribut.
		mov     es:[si],ax        ; Skriv tecknet.

		mov     cx,cs:ROW         ; Hmta raden.
		mov     bx,cs:LAST_COL    ; Hmta kolumnen.
		call    window_offset     ; Rkna ut skrmoffset.
		mov     al,cs:WUR         ; Hmta tecken frn WUR.
		mov     ah,cs:ATTRIBUT    ; Hmta attribut.
		mov     es:[si],ax        ; Skriv tecknet.

		mov     cx,cs:LAST_ROW    ; Hmta raden.
		mov     bx,cs:LAST_COL    ; Hmta kolumnen.
		call    window_offset     ; Rkna ut skrmoffset.
		mov     al,cs:WDR         ; Hmta tecken frn WDR.
		mov     ah,cs:ATTRIBUT    ; Hmta attribut.
		mov     es:[si],ax        ; Skriv tecknet.

		mov     cx,cs:ROW         ; Hmta raden.
		mov     bx,cs:COL         ; Hmta kolumnen.
window_draw_r1: inc     bx                ; ka kolumnen.
		cmp     bx,cs:LAST_COL    ; r det sista kolumnen ?
		jz      window_draw_row2  ; Ja, rita ny linje.
		call    window_offset     ; Hmta skrmoffset.
		mov     al,cs:WDX1        ; Hmta tecken frn WDX1.
		mov     ah,cs:ATTRIBUT    ; Hmta attribut.
		mov     es:[si],ax        ; Skriv tecknet.
		jmp     window_draw_r1    ; Hoppa till 'Hmta kolumn'.

window_draw_row2: mov   cx,cs:LAST_ROW    ; Hmta raden.
		mov     bx,cs:COL         ; Hmta kolumnen.
window_draw_r2: inc     bx                ; ka kolumnen.
		cmp     bx,cs:LAST_COL    ; r det sista kolumnen ?
		jz      window_draw_col1  ; Ja, rita ny linje.
		call    window_offset     ; Hmta skrmoffset.
		mov     al,cs:WDX2        ; Hmta tecken frn WDX2.
		mov     ah,cs:ATTRIBUT    ; Hmta attribut.
		mov     es:[si],ax        ; Skriv tecknet.
		jmp     window_draw_r2    ; Hoppa till 'Hmta kolumn'.

window_draw_col1: mov   bx,cs:COL         ; Hmta kolumnen.
		mov     cx,cs:ROW         ; Hmta raden.
window_draw_c1: inc     cx                ; ka raden.
		cmp     cx,cs:LAST_ROW    ; r det sista raden ?
		jz      window_draw_col2  ; Ja, rita ny linje.
		call    window_offset     ; Hmta skrmoffset.
		mov     al,cs:WDY1        ; Hmta tecken frn WDY1.
		mov     ah,cs:ATTRIBUT    ; Hmta attribut.
		mov     es:[si],ax        ; Skriv tecknet.
		jmp     window_draw_c1    ; Hoppa till 'Hmta rad'.

window_draw_col2: mov   bx,cs:LAST_COL    ; Hmta kolumnen.
		mov     cx,cs:ROW         ; Hmta raden.
window_draw_c2: inc     cx                ; ka raden.
		cmp     cx,cs:LAST_ROW    ; r det sista raden ?
		jz      window_end        ; Ja, avsluta window rutin.
		call    window_offset     ; Hmta skrmoffset.
		mov     al,cs:WDY2        ; Hmta tecken frn WDY2.
		mov     ah,cs:ATTRIBUT    ; Hmta attribut.
		mov     es:[si],ax        ; Skriv tecknet.
		jmp     window_draw_c2    ; Hoppa till 'Hmta rad'.

;+++++++++++++++++++++++++++++++++++++++++++++
;+++                                       +++
;+++      Rknar ut offset skrminnet      +++
;+++                                       +++
;+++  CL=RADNUMMER     BX=KOLUMNNUMMER     +++
;+++                                       +++
;+++++++++++++++++++++++++++++++++++++++++++++
window_offset:  push    ax                ; Spara AX.
		mov     ah,00             ; Nollstll highbyte.
		mov     al,cl             ; Hmta radnummer.
		mul     SCREEN_WIDTH      ; Multiplicera med hundrasextio.
		mov     dx,ax             ; Lgg det i DX.
		mov     ax,bx             ; Hmta kolumnnummer.
		mul     TWO               ; Multiplicera med tv.
		add     dx,ax             ; Lgg ihop AX+DX.
		mov     si,dx             ; Flytta summan till SI.
		add     si,cs:SCREEN_PAGE ; Addera sidoffset.
		pop     ax                ; tervinn AX.
		ret                       ; Hoppa till kallaren.

window_end:     pop     si             ;
		pop     di             ;
		mov     sp,bp          ; Standard avslutning.
		pop     bp             ;
		ret                    ;
_window          ENDP

_no_window      proc   near
		push   bp                   ; Standard inledning.
		mov    bp,sp
		push   di
		push   si

no_window_begin:mov     di,[bp+4]
		mov     cs:SCREEN_AREA,di
		mov     ax,[di]       ; Hmta frsta raden.
		add     di,2          ; ka SCREEN_AREA.
		mov     cs:COL,ax     ; Lgg den i ROW.
		mov     ax,[di]       ; Hmta sista raden.
		add     di,2          ; ka SCREEN_AREA.
		mov     cs:LAST_COL,ax ; Lgg den i ADD_ROW.
		mov     ax,[di]       ; Hmta frsta kolumnen.
		add     di,2          ; ka SCREEN_AREA.
		mov     cs:ROW,ax     ; Lgg den i COL.
		mov     ax,[di]       ; Hmta sista kolumnen.
		add     di,2          ; ka SCREEN_AREA.
		mov     cs:LAST_ROW,ax ; Lgg den i ADD_COL.

		mov     cx,cs:ROW     ; Hmta raden.
no_window_load: mov     bx,cs:COL     ; Hmta kolumnen.
no_window_ld:   call    window_offset ; Rkna ut skrmoffset.
		mov     ax,[di]       ; Hmtar ett tecken frn SCREEN_AREA.
		mov     es:[si],ax    ; Lgger det i skrmminnet.
		add     di,2          ; ka SCREEN_AREA.
		cmp     bx,cs:LAST_COL ; r det sista kolumnen ?
		jz      no_window_next; Ja, hmta ny rad.
		inc     bx            ; Nej, ka kolumnen.
		jmp     no_window_ld  ; Hoppa till 'Rkna ut offset'.
no_window_next: cmp     cx,cs:LAST_ROW ; r det sista raden ?
		jz      no_window_end ; Ja,avslut no_window rutin.
		inc     cx            ; Nej, ka raden.
		jmp     no_window_load; Hoppa till 'Rkna ut offset'.

no_window_end:  pop     si             ;
		pop     di             ;
		mov     sp,bp          ; Standard avslutning
		pop     bp             ;
		ret                    ;
_no_window      ENDP

		_TEXT   ENDS
		END

