;RESIDENT.ASM - A shell for the making of resident programs
;Written June 1986 by John Martin

;Definition of constants used by this code

DOS_io          equ     xxh     ;I/O vector number
DOS_function    equ     21h     ;The DOS function interrupt
DOS_ret         equ     20h     ;Quit program, return to DOS
DOS_terminate   equ     27h     ;Terminate & stay interrupt
get_vector      equ     35h     ;function number for get-vector
set_vector      equ     25h     ;function number for set-vector


code    segment    para public 'code'
        assume     cs:code
        org        0100h


start:  jmp     init

;Any variables that your application needs must be placed here.

old_int   label  dword
old_io    dw   2 dup (?)           ;set aside a double word for old I/O


;Here you place your program checking for the event you
;want to interrupt.
;Don't remove any of my code, it's needed for the rouine to work.

int_routine     proc near
        sti                     ;turn interrupts back on
        push    ax              ;save registers
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    ds
        push    es

oldint: pushf                   ;Push flags to simulate an INT call
        call    old_io          ;INT-handler, we just use it.

        pop     es
        pop     ds
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        iret

int_routine     endp


init    proc    near

        mov     al,DOS_io       ;Set al the the vector we use
        mov     ah,get_vector   ;Use DOS-function call to get
        int     DOS_function    ;it's address.

        mov     old_io,bx       ;Old vector is returned in ES:BX
        mov     old_io[2],es    ;save it to variable.

        mov     bx,cs           ;DOS function wants vector in DS:DX
        mov     ds,bx
        mov     dx,offset int_routine
        mov     al,DOS_io       ;Use DOS function call to set it.
        mov     ah,set_vector
        int     DOS_function

        mov     dx,sign_on      ;display signon message
        mov     ah,09h
        int     DOS_function

        mov     bx,offset init
        int     DOS_terminate   ;Terminate & Stay

        int     DOS_ret         ;Return to DOS


init    endp

sign_on:        db    'TSR-installed',10,10,13,'$'

code    ends

        end     start
