	CODE    SEGMENT         BYTE    PUBLIC  'code'
		ASSUME  CS:CODE,DS:CODE,ES:CODE

	ORG     100H

	SAVSCR  PROC    FAR

BEGIN:
	JMP     START   ; Start addr when run from command

intvec: PUSH    AX
	PUSH    BX
        PUSH    CX
        PUSH    DX
        PUSH    SI
        PUSH    DI
	PUSH    ES
	PUSH    DS
	STI                             ; Allow interrupts

	mov     dx,offset filen
	push    cs
	pop     ds
	MOV     CX,0000H        ; Attribute bits zero
	MOV     AH,3CH          ; Create a file or if it exists, set the
	INT     21H             ; length to zero

	mov     bx,0a000h
	push    bx
	pop     ds
	xor     dx,dx
	mov     bx,ax

	mov     cx,16
	MOV     AH,40H
	INT     21H     ; Do the write
	JNC     WRITEOK
	JMP     SHORT BEEP4
writeok:
	mov     dx,03ceh               ; Write Plane #0
	mov     al,4
	out     dx,al
	mov     dx,03cfh
	mov     al,0
	out     dx,al
	mov     cx,80*350
	mov     ah,40h
	int     21h
	mov     dx,03ceh                ; Write Plane #1
	mov     al,4
	out     dx,al
	mov     dx,03cfh
	mov     al,1
	out     dx,al
	mov     cx,80*350
	mov     ah,40h
	int     21h
	mov     dx,03ceh                ; Write Plane #2
	mov     al,4
	out     dx,al
	mov     dx,03cfh
	mov     al,2
	out     dx,al
	mov     cx,80*350
	mov     ah,40h
	int     21h
	mov     dx,03ceh                ; Write Plane #3
	mov     al,4
	out     dx,al
	mov     dx,03cfh
	mov     al,3
	out     dx,al
	mov     cx,80*350
	mov     ah,40h
	int     21h
	mov     dx,03ceh                ; Restore
	mov     al,4
	out     dx,al
	mov     dx,03cfh
	mov     al,0
	out     dx,al

	MOV     AH,3EH
	INT     21H     ; CLOSE FILE
	JNC     iexit
	JMP     SHORT BEEP4

BEEP4:  MOV     DL,7    ; Some kind of file error occured so
	MOV     AH,2    ; just send a BEEP and exit
	INT     21H

IEXIT:  pop     ds
	POP     ES
        POP     DI
        POP     SI
        POP     DX
        POP     CX
        POP     BX
        POP     AX
        IRET

FILEN   DB      "EGAPIC.PIC",00

IEND:           ; End of resident code. Buffer area overlays the following


INITMSG DB      'SaveEga, screen saving program is resident. (V0.1)',13,10
	DB      'Use Shift-PrtSc to write the screen to a file.',13,13,10
	DB      '1987, .',13,10,'$'

BADDOS  DB      'Sorry, DOS must be 2.0 or greater',13,10,'$'

START:
        PUSH    CS              ; Initial installation starts here
        POP     DS
        PUSH    CS
        POP     ES
        MOV     AH,30H          ; Check DOS version
        INT     21H
        CMP     AL,2
        JGE     DOSOK
	MOV     DX,offset BADDOS
        CALL    WRTMSG
	JMP     LEAVE
DOSOK:
	MOV     DX,OFFSET INTVEC        ; DS already has CS
	MOV     AX,2505h                ; Set our interrupt handler entry
        INT     21H
	MOV     DX,offset INITMSG       ; and say we are loaded
        MOV     AH,09H
	INT     21H

	MOV     DX,offset IEND          ; Figure out how much to leave
	MOV     CL,4                    ; Make a paragraph boundary
        SHR     DX,CL
	INC     DX                      ; and round up
        MOV     AH,31H
        MOV     AL,0
	INT     21H                     ; Terminate and stay resident

WRTMSG  PROC                            ; WRITE A MSG
	push    cs
	pop     ds
        MOV     AH,09H
        INT     21H
        RET
WRTMSG  ENDP

LEAVE:  INT     20H

SAVSCR  ENDP
	code    ENDS
		END     BEGIN


